#ifndef __CONSTANTUNFOLD_H__
#define __CONSTANTUNFOLD_H__

#include "LoopDetection.h"
#include <unordered_map>
#include <vector>
#include <cmath>
#include "MachineCode.h"
#include "Function.h"
#include "Vectorization.h"

class ConstantUnfold
{
public:
    ConstantUnfold(Unit* unit){this->unit = unit;}
    void pass();
    void pass2();
    void checkLoop(blockSet* oneloop,Function* func);
    void checkLoop(Function* func);
    void unfold(loop_item* oneloop, Function* func);
    void unfold(blockSet* oneloop, Function* func);

private:
    LoopDetection* detector;
    //int phiCount;
    Unit* unit;
    BasicBlock* condbb;
    BasicBlock* bodybb;
    BasicBlock* endbb;
};

#endif