#ifndef DEADCODEELIMATE_H
#define DEADCODEELIMATE_H
#include "Instruction.h"
#include "Type.h"
#include "Unit.h"
#include <set>
#include <unordered_set>

class DeadCodeEliminate {
    Unit *unit;
    int inst_counter = 0;
    int store_counter = 0;
    int func_counter = 0;
    std::unordered_set<Function *> notSideEffectFunc;
    std::unordered_set<Instruction *> worklist;
    std::unordered_set<std::string> worklist_op;

  public:
    DeadCodeEliminate(Unit *_unit) : unit(_unit) {}
    void execute();
    void clearNoPred();

    bool isSideEffect(Instruction *inst);
    bool isSideEffect_main(Instruction *inst);
    bool isSideEffectFunc(Function *func) {
        return notSideEffectFunc.find(func) == notSideEffectFunc.end();
    }

    void detectNotSideEffectFunc();
    bool getRelationRes(unsigned opcode, double value1, double value2);
    void deleteDeadFunc();
    void deleteDeadInst(Function *func);
    void deleteDeadStore(Function *func);
    void deleteDeadRet(Function *func);
    void deadBranchDetection();
    void markUse(Instruction *inst);
    void markUse_print(Instruction *inst, int level);
    void executeFront();
    void deleteDeadInstFront(Function *func);
};

#endif // DEADCODEELIMATE_H