#include "GlobalVarLocalization.h"
#include <queue>
using namespace std;

#define DEBUG_SWITCH_g2l 0
#if DEBUG_SWITCH_g2l
#define printG2L(str) std::cout << str << "\n";
#else
#define printG2L(str) //
#endif


// ºȫϢ
void GlobalVariableLocalization::updateGlobalInformation(int callerIndex, int calleeIndex) {
    Function* callerFunc = funclist[callerIndex];
    Function* calleeFunc = funclist[calleeIndex];

    // ºcallerFuncȫּϢ
    for(auto it: funcUsages[calleeFunc]) {
        if(gLoads_closure[it].count(calleeFunc)) {
            gLoads_closure[it].insert(callerFunc);
        }
    }

    // ºcallerFuncȫִ洢Ϣ
    for(auto it: funcUsages[calleeFunc]) {
        if(gStores_closure[it].count(calleeFunc)) {
            gStores_closure[it].insert(callerFunc);
        }
    }
}


void GlobalVariableLocalization::recursiveLookup() {
    //TODO:ݹȫֱϢ;
    int num_func = func2idx.size();
    printG2L(num_func)
    vector<vector<bool>> topological(num_func, vector<bool>(num_func, false));
    for(auto caller: func2idx) {
        for(auto callee: callmap[caller.first]) {
            int row = func2idx[caller.first];
            int col = func2idx[callee];
            printG2L("row: " << row  << "   col: " << col)
            topological[row][col] = true;
        }
    }

    vector<int> in_degree(num_func);
    // ÿ
    for (int i = 0; i < num_func; i++) {
        for (int j = 0; j < num_func; j++) {
            if(topological[i][j]){
                in_degree[i]++;
            }
        }
    }

    queue<int> worklist;
    for(int i = 0; i < num_func; i++){
         if(!in_degree[i]) {
            worklist.push(i); //Ҷڵ;
        }
    }

    while(!worklist.empty()) {
        int head = worklist.front();
        worklist.pop();

        for(int i = 0; i < num_func; i++){
            if(topological[i][head]){
                 updateGlobalInformation(i, head);
                 in_degree[i]--;
                 if(!in_degree[i]) {
                    worklist.push(i);
                 }
            }
        }
    }
}

void GlobalVariableLocalization::gLocalization(Function* func) {
    if(funcUsages.count(func) == 0) {
        return;
    }
    auto worklist = this->funcUsages[func];
    if(worklist.empty()) {
        return;
    }

    // printG2L("gStores2: ");
    // for(auto it1: gStores){
    //     printG2L("    " << it1.first->toStr() << ": ");
    //     for(auto it2: it1.second) {
    //         printG2L("    " << "    " << it2.first->getSymPtr()->toStr());
    //     }
    // }

    map<SymbolEntry*, Operand*> Global2Local;
    for(auto globalSE: worklist) {
        if (((IdentifierSymbolEntry*)globalSE)->getConst()) { 
            continue; //ֵ, ;
        }
        Type* type = ((PointerType*)(globalSE->getType()))->getType();
        if(type->isArray()) {
            continue; //ͣ;
        }
        
        //ںʼǰֲȫֱ:
        auto loacalSe = new TemporarySymbolEntry(new PointerType(type), SymbolTable::getLabel());
        // auto loacalSe = new IdentifierSymbolEntry(new PointerType(type), SymbolTable::getLabel());
        Operand* local = new Operand(loacalSe);
        auto allocaInst = new AllocaInstruction(local, new TemporarySymbolEntry(type, 0)); //һֲ;
        auto se = dynamic_cast<TemporarySymbolEntry*>(dynamic_cast<AllocaInstruction*>(allocaInst)->getSymbolEntry());
        se->setG2L();
        
        //ȫֱֵloadstoreֲȥ:
        SymbolEntry* globalSE_copy = new IdentifierSymbolEntry(*((IdentifierSymbolEntry*)globalSE));
        globalSE_copy->setType(new PointerType(type));
        Operand* global_copy = new Operand(globalSE_copy);

        Operand* temp = new Operand(new TemporarySymbolEntry(type, SymbolTable::getLabel()));
        auto loadInst = new LoadInstruction(temp, global_copy); //loadȫֱֵ;
        auto storeInst = new StoreInstruction(local, temp); //loadֵstorelocal;
        
        printG2L("Inst prepared well.");
        
        //allocaInst뵽ڴ:
        auto entryBB = func->getEntry();
        entryBB->insertFront(allocaInst);
        allocaInst->setParent(entryBB);

        printG2L("Inst inserted.");

        for (auto inst = entryBB->begin(); inst != entryBB->end(); inst = inst->getNext()) {
            if (!inst->isAlloc()) { //loadInst뵽allocaInst֮, storeInst;
                entryBB->insertBefore(loadInst, inst);
                entryBB->insertAfter(storeInst, loadInst);
                loadInst->setParent(entryBB);
                storeInst->setParent(entryBB);
                break;
            }
        }

        // printG2L("gStores3: ");
        // for(auto it1: gStores){
        //     printG2L("    " << it1.first->toStr() << ": ");
        //     for(auto it2: it1.second) {
        //         printG2L("    " << "    " << it2.first->getSymPtr()->toStr());
        //     }
        // }

        //ȫֱĶд滻ɾֲ: global->local
        if(gLoads[globalSE].count(func)) {
            for (auto inst : gLoads[globalSE][func]) {
                inst->replaceUse(inst->getUse()[0], local);
                inst->replace_opse(local->getSymbolEntry(), inst->getOpse()[0]);
            }
        }
        if(gStores[globalSE].count(func)) {
            for (auto inst : gStores[globalSE][func]) {
                inst->replaceDef(local);
                inst->replace_opse(local->getSymbolEntry(), inst->getOpse()[0]);
            }
        }

        // printG2L("gStores4: ");
        // for(auto it1: gStores){
        //     printG2L("    " << it1.first->toStr() << ": ");
        //     for(auto it2: it1.second) {
        //         printG2L("    " << "    " << it2.first->getSymPtr()->toStr());
        //     }
        // }

        //ӳϵ
        Global2Local[globalSE] = local;

        printG2L("global->local mapped: " << globalSE->toStr() << " -> " << local->getSymbolEntry()->toStr());
        
    }

    // printG2L("gStores5: ");
    // for(auto it1: gStores){
    //     printG2L("    " << it1.first->toStr() << ": ");
    //     for(auto it2: it1.second) {
    //         printG2L("    " << "    " << it2.first->getSymPtr()->toStr());
    //     }
    // }


    //غͺ:
    for (auto bb: func->getBlockList()) {
        for (auto inst = bb->begin(); inst != bb->end(); inst = inst->getNext()) {
            if(inst->getInstType() == Instruction::CALL) {
                SymbolEntry* func_SE = ((CallInstruction*)(inst))->getSymEntry();
                if (((IdentifierSymbolEntry*)func_SE)->isSysy() 
                        || ((IdentifierSymbolEntry*)func_SE)->getName() == "llvm.memset.p0.i32") { //ų⺯
                            continue;
                    }
                printG2L("CALL: " << func_SE->toStr());
                Function*  func_called = ((IdentifierSymbolEntry*)(func_SE))->getFunction();
                
                //ݹ:
                if(func->getSymPtr()->toStr() == func_SE->toStr()) {
                    printG2L("recursiveCALL");
                    // printG2L("funcUsages: " );
                    // for(auto it1: funcUsages){
                    //     printG2L("    " << it1.first->getSymPtr()->toStr() << " : ");
                    //     for(auto it2: it1.second) {
                    //         printG2L("    " << "    " << it2->toStr());
                    //     }
                    // }
                    if(this->funcUsages.count(func))
                    for(auto globalSE: this->funcUsages[func]) {
                        // if(this->gStores[globalSE].count(func)) { 
                        {
                            printG2L(func->getSymPtr()->toStr() << " has gLoads: " << globalSE->toStr());
                            printG2L(func_SE->toStr() << " has gStores: " << globalSE->toStr());
                            Type* type = ((PointerType*)(globalSE->getType()))->getType();
                            Operand* temp = new Operand(new TemporarySymbolEntry(type, SymbolTable::getLabel()));
                            
                            SymbolEntry* globalSE_copy = new IdentifierSymbolEntry(*((IdentifierSymbolEntry*)globalSE));
                            globalSE_copy->setType(new PointerType(type));
                            Operand* global_copy = new Operand(globalSE_copy);
                            auto loadInst = new LoadInstruction(temp, global_copy); 
                            auto storeInst = new StoreInstruction(Global2Local[globalSE], temp);
                            printG2L("Inst prepared well.");
                            
                            bb->insertAfter(loadInst, inst);
                            bb->insertAfter(storeInst, loadInst);
                            storeInst->setParent(bb);
                            loadInst->setParent(bb);
                            printG2L("Inst inserted.");
                        }
                        // if(this->gStores[globalSE].count(func)) {
                        {
                            printG2L(func->getSymPtr()->toStr() << " has gStores: " << globalSE->toStr());
                            printG2L(func_SE->toStr() << " has gLoads: " << globalSE->toStr());
                            Type* type = ((PointerType*)(globalSE->getType()))->getType();
                            Operand* temp = new Operand(new TemporarySymbolEntry(type, SymbolTable::getLabel()));
                            auto loadInst = new LoadInstruction(temp, Global2Local[globalSE]); 
                            bb->insertBefore(loadInst, inst);
                            loadInst->setParent(bb);

                            SymbolEntry* globalSE_copy = new IdentifierSymbolEntry(*((IdentifierSymbolEntry*)globalSE));
                            globalSE_copy->setType(new PointerType(type));
                            Operand* global_copy = new Operand(globalSE_copy);
                            auto storeInst = new StoreInstruction(global_copy, temp);
                            bb->insertBefore(storeInst, inst);
                            storeInst->setParent(bb);
                            printG2L("Inst inserted.");
                        }
                    }
                    continue;
                }


                // printG2L("funcUsages: " );
                // for(auto it1: funcUsages){
                //     printG2L("    " << it1.first->getSymPtr()->toStr() << " : ");
                //     for(auto it2: it1.second) {
                //         printG2L("    " << "    " << it2->toStr());
                //     }
                // }
                
                // printG2L("gLoads: " );
                // for(auto it1: gLoads){
                //     printG2L("    " << it1.first->toStr() << ": ");
                //     for(auto it2: it1.second) {
                //         printG2L("    " << "    " << it2.first->getSymPtr()->toStr());
                //     }
                // }

                // printG2L("gStores_closure: ");
                // for(auto it1: gStores_closure){
                //     printG2L("    " << it1.first->toStr() << ": ");
                //     for(auto it2: it1.second) {
                //         printG2L("    " << "    " << it2->getSymPtr()->toStr());
                //     }
                // }


                if(this->funcUsages.count(func))
                for(auto globalSE: this->funcUsages[func]) {
                    printG2L("process: " << globalSE->toStr());
                    if((this->gLoads[globalSE].count(func) || this->gLoads_closure[globalSE].count(func)) && 
                            (this->gStores[globalSE].count(func_called) ||
                            this->gStores_closure[globalSE].count(func_called))) { //Caller read, Callee write.

                        printG2L(func->getSymPtr()->toStr() << " has gLoads: " << globalSE->toStr());
                        printG2L(func_SE->toStr() << " has gStores or gStores_closure: " << globalSE->toStr());

                        Type* type = ((PointerType*)(globalSE->getType()))->getType();
                        Operand* temp = new Operand(new TemporarySymbolEntry(type, SymbolTable::getLabel()));
                        
                        SymbolEntry* globalSE_copy = new IdentifierSymbolEntry(*((IdentifierSymbolEntry*)globalSE));
                        globalSE_copy->setType(new PointerType(type));
                        Operand* global_copy = new Operand(globalSE_copy);
                        auto loadInst = new LoadInstruction(temp, global_copy); 
                        auto storeInst = new StoreInstruction(Global2Local[globalSE], temp);
                        printG2L("Inst prepared well.");
                        
                        bb->insertAfter(loadInst, inst);
                        bb->insertAfter(storeInst, loadInst);
                        storeInst->setParent(bb);
                        loadInst->setParent(bb);
                        printG2L("Inst inserted.");
                    }
                    if((this->gStores[globalSE].count(func) || this->gStores_closure[globalSE].count(func))&&
                             (this->gLoads.count(globalSE) || 
                            this->gLoads_closure.count(globalSE))) { //Caller write, Callee read.

                        printG2L(func->getSymPtr()->toStr() << " has gStores: " << globalSE->toStr());
                        printG2L(func_SE->toStr() << " has gLoads or gLoads_closure: " << globalSE->toStr());
                        Type* type = ((PointerType*)(globalSE->getType()))->getType();
                        Operand* temp = new Operand(new TemporarySymbolEntry(type, SymbolTable::getLabel()));
                        auto loadInst = new LoadInstruction(temp, Global2Local[globalSE]); 
                        bb->insertBefore(loadInst, inst);
                        loadInst->setParent(bb);

                        SymbolEntry* globalSE_copy = new IdentifierSymbolEntry(*((IdentifierSymbolEntry*)globalSE));
                        globalSE_copy->setType(new PointerType(type));
                        Operand* global_copy = new Operand(globalSE_copy);
                        auto storeInst = new StoreInstruction(global_copy, temp);
                        bb->insertBefore(storeInst, inst);
                        storeInst->setParent(bb);
                        printG2L("Inst inserted.");
                    }
                }
                printG2L("CALL: " << func_SE->toStr() << " processed.");
            } else if(inst->getInstType() == Instruction::RET) {
                if(this->funcUsages.count(func))
                for(auto globalSE: this->funcUsages[func]) {
                    if(this->gStores.count(globalSE)) {
                        Type* type = ((PointerType*)(globalSE->getType()))->getType();
                        Operand* temp = new Operand(new TemporarySymbolEntry(type, SymbolTable::getLabel()));
                        auto loadInst = new LoadInstruction(temp, Global2Local[globalSE]); 
                        bb->insertBefore(loadInst, inst);
                        loadInst->setParent(bb);

                        SymbolEntry* globalSE_copy = new IdentifierSymbolEntry(*((IdentifierSymbolEntry*)globalSE));
                        globalSE_copy->setType(new PointerType(type));
                        Operand* global_copy = new Operand(globalSE_copy);
                        auto storeInst = new StoreInstruction(global_copy, temp);
                        bb->insertBefore(storeInst, inst);
                        storeInst->setParent(bb);
                    }
                }
            }
        }
    }
}

void GlobalVariableLocalization::pass() {
    printG2L("GlobalVariableLocalization::pass begin.");
    auto func = unit->begin();
    int index = 0;
    while (func != unit->end()) {
        for(auto bb: (*func)->getBlockList()) {
            for(auto inst = bb->begin(); inst != bb->end(); inst = inst->getNext()) {
                if(inst->getInstType() == Instruction::LOAD && inst->getUse()[0]->isGlobal()) {
                    auto useSE = inst->getUse()[0]->getEntry();
                    this->funcUsages[*func].insert(useSE); //ӵglobalϢУ
                    this->gLoads[useSE][*func].push_back(inst); //ӵLoadӳ;
                    this->gLoads_closure[useSE].insert(*func); 
                    printG2L("gLoads push_back: " << (*func)->getSymPtr()->toStr() << " " << useSE->toStr());
                } else if(inst->getInstType() == Instruction::STORE && inst->getDef()->isGlobal()) {
                    auto defSE = inst->getDef()->getEntry();
                    this->funcUsages[*func].insert(defSE); //ӵglobalϢУ
                    this->gStores[defSE][*func].push_back(inst); //ӵStoreӳ;
                    this->gStores_closure[defSE].insert(*func); 
                    printG2L("gStores push_back: " << (*func)->getSymPtr()->toStr() << " " << defSE->toStr());
                }
                //ͳƵùϵ:
                if(inst->getInstType() == Instruction::CALL) {
                    SymbolEntry* func_SE = ((CallInstruction*)(inst))->getSymEntry();
                    if (((IdentifierSymbolEntry*)func_SE)->isSysy() 
                        || ((IdentifierSymbolEntry*)func_SE)->getName() == "llvm.memset.p0.i32") { //ų⺯
                            continue;
                    }
                    Function*  func_called = ((IdentifierSymbolEntry*)(func_SE))->getFunction();
                    this->callmap[*func].insert(func_called);
                }
            }
        }
        funclist.push_back(*func);
        func2idx[*func] = index++;
        *func++;
    }

    printG2L("information collected.");

    printG2L("funcUsages: " );
    for(auto it1: funcUsages){
        printG2L("    " << it1.first->getSymPtr()->toStr() << " : ");
        for(auto it2: it1.second) {
            printG2L("    " << "    " << it2->toStr());
        }
    }
    printG2L("gLoads: " );
    for(auto it1: gLoads){
        printG2L("    " << it1.first->toStr() << ": ");
        for(auto it2: it1.second) {
            printG2L("    " << "    " << it2.first->getSymPtr()->toStr());
        }
    }
    printG2L("gStores: ");
    for(auto it1: gStores){
        printG2L("    " << it1.first->toStr() << ": ");
        for(auto it2: it1.second) {
            printG2L("    " << "    " << it2.first->getSymPtr()->toStr());
        }
    }

    //ݹϢ:
    printG2L("recursiveLookup begin.");
    recursiveLookup();

    printG2L("gLoads_closure: " );
    for(auto it1: gLoads_closure){
        printG2L("    " << it1.first->toStr() << ": ");
        for(auto it2: it1.second) {
            printG2L("    " << "    " << it2->getSymPtr()->toStr());
        }
    }
    printG2L("gStores_closure: ");
    for(auto it1: gStores_closure){
        printG2L("    " << it1.first->toStr() << ": ");
        for(auto it2: it1.second) {
            printG2L("    " << "    " << it2->getSymPtr()->toStr());
        }
    }



    printG2L("recursiveLookup finshed.");


    // ͵ȫֱ:
    printG2L("ConstantSymbolEntry replaceUse begin.");
    for(auto func = unit->begin(); func != unit->end(); func++) {
        printG2L((*func)->getSymPtr()->toStr() << "processed.")
        vector<SymbolEntry*> replacelist;

        if(this->funcUsages.count(*func))
        for(auto globalSE: this->funcUsages[*func]) {
            Type* type = ((PointerType*)(globalSE->getType()))->getType();
            if(type->isArray()) {
                //TODO:;
                // // if(!this->gStores.count(globalSE)) { //ֱжϣΪgepӵstore;
                // bool ifStored = false;
                // for(auto inst: gLoads[globalSE][*func]) {
                //     auto def0 = inst->getDef();
                //     for(auto it0 = def0->use_begin(); it0 != def0->use_end(); it0++) {
                //         if((*it0)->isStore()) {
                //             ifStored = true;
                //             break;
                //         } else if((*it0)->isGep()) { //һά;
                //             auto def1 = (*it0)->getDef();
                //             for(auto it1 = def1->use_begin(); it1 != def1->use_end(); it1++) {
                //                 if((*it1)->isStore()) {
                //                     ifStored = true;
                //                     break;
                //                 } else if((*it1)->isGep()) { //ά;
                //                     auto def2 = inst->getDef();
                //                     for(auto it2 = def2->use_begin(); it2 != def2->use_end(); it2++) {
                //                         if((*it1)->isStore()) {
                //                             ifStored = true;
                //                             break;
                //                         } else if((*it1)->isGep()) {
                //                             ifStored = true;
                //                             break;
                //                         }
                //                     }
                //                     if(ifStored) break;
                //                 }
                //             }
                //             if(ifStored) break;
                //         }
                //     }
                //     if(ifStored) break;
                // }

                // //滻ûдȫԪ:
                // if(!ifStored) {
                //     for(auto inst: gLoads[globalSE][*func]) {
                //         auto def0 = inst->getDef();
                //         for(auto it0 = def0->use_begin(); it0 != def0->use_end(); it0++) {
                //             if((*it0)->isGep()) {
                //                 auto def1 = inst->getDef();
                //                 auto use1 = inst->getUse()[1];
                //                 if(use1->isConst()) {
                //                     auto index = use1->getConstVal();
                //                     auto elementType = ((ArrayType*)type)->getElementType();
                //                     for(auto it1 = def1->use_begin(); it1 != def1->use_end(); it1++) {
                //                         if((*it1)->isLoad()) {
                //                             auto dst = (*it1)->getDef();
                //                             auto tempSE = identifiers->lookup(globalSE->toStr());
                //                             double* base = ((IdentifierSymbolEntry*)tempSE)->getArrayValue();

                //                             double value = 0;
                //                             if (base) value = base[index];
                //                             auto temp = new Operand(new ConstantSymbolEntry(elementType, value));
                //                             while (dst->use_begin() != dst->use_end()) {
                //                                 auto use = *(dst->use_begin());
                //                                 use->replaceUse(dst, temp);
                //                             }
                //                             (*it1)->getParent()->remove(*it1);
                //                         } else if((*it1)->isGep()) {
                //                             index = index * ((ArrayType*)elementType)->getLength();
                //                             auto use2 = (*it1)->getUse()[1];
                //                             if(use2->isConst()) {
                //                                 auto index2 = use2->getConstVal();
                //                                 index = index + index2;
                //                                 auto elementType2 = ((ArrayType*)elementType)->getElementType();

                //                                 auto dst = (*it1)->getDef();
                //                                 for (auto it3 = dst->use_begin(); it3 != dst->use_end(); it3++) {
                //                                     if ((*it3)->isLoad()) {
                //                                         auto dst = (*it3)->getDef();
                //                                         auto tempSE = identifiers->lookup(globalSE->toStr());
                //                                         double* base = ((IdentifierSymbolEntry*)tempSE)->getArrayValue();
                //                                         double value = 0;

                //                                         if (base) value = base[index];
                //                                         auto temp = new Operand(new ConstantSymbolEntry(elementType, value));
                //                                         while (dst->use_begin() != dst->use_end()) {
                //                                             auto use = *(dst->use_begin());
                //                                             use->replaceUse(dst, temp);
                //                                         }
                //                                         (*it3)->getParent()->remove(*it3);
                //                                     }
                //                                 }
                //                             }
                //                         }
                //                     }
                //                 }
                //             }
                //         }
                //     }
                // }
            } else {
                if(!this->gStores.count(globalSE)) { //ûдȫֱ;
                    printG2L(globalSE->toStr() << ": read only!")
                    auto tempSE = identifiers->lookup(globalSE->toStr());
                    Operand* temp = new Operand(new ConstantSymbolEntry(
                        type, ((IdentifierSymbolEntry*)tempSE)->getValue())); //ֱֵͬʱ滻;
                    printG2L(globalSE->toStr() << " => " << temp->getSymbolEntry()->toStr())
                    for(auto inst: gLoads[globalSE][*func]) {
                        auto def = inst->getDef(); //Loadָ, loadļΪȫֱ;
                        printG2L(def->getSymbolEntry()->toStr() << ": been replaced!")
                        while (def->use_begin() != def->use_end()) {
                            auto use = *(def->use_begin());
                            use->replaceUse(def, temp);
                        }
                        inst->getParent()->remove(inst); //ɾload;
                    }
                    gLoads[globalSE].erase(*func); //gLoadsƳ;
                    replacelist.push_back(globalSE);
                }
            }
        }
        for(auto globalSE: replacelist) {
            funcUsages[*func].erase(globalSE); //funcUsagesƳ;
        }
    }
    printG2L("ConstantSymbolEntry replaceUse end.");




    //δ:
    for(auto func = unit->begin(); func != unit->end(); func++) {
        // printG2L("gStores1: ");
        // for(auto it1: gStores){
        //     printG2L("    " << it1.first->toStr() << ": ");
        //     for(auto it2: it1.second) {
        //         printG2L("    " << "    " << it2.first->getSymPtr()->toStr());
        //     }
        // }

        printG2L("gLocalization: " << (*func)->getSymPtr()->toStr() << "  begin.");
        gLocalization(*func);
        printG2L("gLocalization: " << (*func)->getSymPtr()->toStr() << "  finished.");
    }
    
    
}