#include "Vectorization.h"
#include "Instruction.h"
#include <unordered_set>
#include "Unit.h"
#define ITERBOUND 40


bool asmChange = 0;

// #define DEBUG0429

void Vectorization::pass()
{
    #ifdef DEBUG0429
    std::cout<<"Vectorization::pass()\n";
    #endif
    std::vector<Function*> func_list = unit->get_functions();
    #ifdef DEBUG0429
    std::cout<<"func_list.size() = "<<func_list.size()<<"\n";
    #endif
    for(auto func = func_list.begin(); func != func_list.end(); func++){
        checkLoop(*func);
    }
    // LoopDetection* loopdetection = new LoopDetection(unit);
    // getchar();
    // loopdetection->run();
    // // printf("before traverse loops\n");
    // // 获取所有的循环（嵌套的循环算一个？）
    // std::vector<blockSet*> innerLoops;
    // for(auto oneloop = loopdetection->begin(); oneloop != loopdetection->end(); oneloop ++)
    // {
    //     if(loopdetection->isBaseLoop(*oneloop))
    //     {
    //         innerLoops.push_back(*oneloop);
    //         BasicBlock* body_bb = *((*oneloop)->begin());
    //         printf("bodybb = %d\n", body_bb->getNo());
    //     }
    //     // printf("oneloop\n");
    //     // BasicBlock* cond_bb = loopdetection->getLoopEntry(*oneloop);
    //     // BasicBlock* body_bb = loopdetection->getLoopCond(*oneloop);
    //     // BasicBlock* end_bb = loopdetection->getLoopOut(*oneloop);
    //     // printf("cond_bb = %d\n", cond_bb->getNo());
    //     // printf("body_bb = %d\n", body_bb->getNo());
    //     // printf("end_bb = %d\n", end_bb->getNo());
    //     // printf("oneloop2\n");
    //     // getchar();
    // }
    // 如果bodybb的前驱块不是2个，返回
    // 如果有函数调用，不做
    // 如果bodybb里的phi指令不止一条，不做
}

void Vectorization::checkLoop(Function* func)
{
    #ifdef DEBUG0429
    std::cout<<"ConstantInfold::checkLoop()\n";
    #endif
    std::vector<loop_item*> loop_list = func->getLoopList();
    std::vector<loop_item*> certificate_loops;
    #ifdef DEBUG0429
    std::cout<<"func->getLoopList().size = "<<func->getLoopList().size()<<"\n";
    #endif
    for(auto oneloop = loop_list.begin(); oneloop != loop_list.end(); oneloop ++)
    {
        loop_item* loopbbs = *oneloop;
    #ifdef DEBUG0429
        std::cout<<"cond_bb no = "<<loopbbs->cond_bb->getNo()<<"\n";
        std::cout<<"while_bb no = "<<loopbbs->while_bb->getNo()<<"\n";
        std::cout<<"end_bb no = "<<loopbbs->end_bb->getNo()<<"\n";
    #endif
        //if(!loopbbs.isBaseLoop())continue;
        //if(loopbbs.getsize() != 2)continue;
        //BasicBlock* body_bb = loopbbs->while_bb;//这里zkd代码是用一个循环找的，为什么？
        if(loopbbs->while_bb->getSuccBlock().size() != 2)
        {
            continue;
    #ifdef DEBUG0429
            std::cout<<"loopbbs->while_bb->getSuccBlock().size() = "<<loopbbs->while_bb->getSuccBlock().size()<<"\n";
            std::cout<<loopbbs->while_bb->getSuccBlock()[0]->getNo()<<"\n";
            std::cout<<loopbbs->while_bb->getSuccBlock()[1]->getNo()<<"\n";
            std::cout<<"loopbbs->while_bb->getSuccBlock().size() != 1 continue\n";
    #endif
        }
        certificate_loops.push_back(loopbbs);
    }
    #ifdef DEBUG0429
    std::cout<<"below transfer certificate_loops\n";
    #endif
    for(loop_item* oneloop : certificate_loops)
    {
    #ifdef DEBUG0429
        std::cout<<"certificate_loop s onelooop\n";
    #endif
        //一个关于cond块的后继块是不是body块的测试
        //检查body块中是否存在call指令
        BasicBlock* body_bb = oneloop->while_bb;//这里zkd代码是用一个循环找的，为什么？
        bool hasCall = false;
        for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
        {
            if(dynamic_cast<CallInstruction*>(ins))hasCall = false;
            
        }
        if(hasCall)
        {
    #ifdef DEBUG0429_terminal
            std::cout<<"hasCall continue\n";
    #endif
            continue;
        }
        int phiCount = 0;
        BasicBlock* while_bb = oneloop->while_bb;
        for(Instruction* ins = while_bb->begin(); ins != while_bb->end(); ins = ins->getNext())
        {
            if(ins->isPhi() == true)phiCount ++;
        }
        if(phiCount != 1)
        {
    #ifdef DEBUG0429_terminal
            std::cout<<"phiCount = "<<phiCount<<"\n";
            std::cout<<"phiCount != 1\n";
    #endif
            return;
        }
    #ifdef DEBUG0429
        std::cout<<"call doVectorization\n";
    #endif
        doVectorization(oneloop, func);
        // wzr: 目前先只做一个循环的向量化
        return;
    }
}

// 以下是一些方便调试的工具函数
void display_instruction(Instruction* ins)
{
    printf("inst pointer = %d, inst type = %s\n", ins, ins->getInstName().c_str());
    for(int i = 0; i < ins->getOp().size(); i ++)
    {
        printf("op%d label = %d\n", i, ins->getOp()[i]->getLabel());
    }
    if(ins->isCond())
    {
        CondBrInstruction* cond = dynamic_cast<CondBrInstruction*>(ins);
        printf(", truebranch = %d, falsebranch = %d\n", cond->getTrueBranch()->getNo(), cond->getFalseBranch()->getNo());
    }
    else if(ins->isUncond())
    {
        UncondBrInstruction* uncond = dynamic_cast<UncondBrInstruction*>(ins);
        printf(", branch = %d\n", uncond->getBranch()->getNo());
    }
    else
    {
        printf("\n");
    }
    // printf("\n");
}

void displayBB(BasicBlock* bb)
{
    printf("The BB No = %d\n", bb->getNo());
    for(Instruction* ins = bb->begin(); ins != bb->end(); ins = ins->getNext())
    {
        display_instruction(ins);
    }
    printf("The BB No = %d end\n", bb->getNo());
}

// 返回块中第一条具有指定类型的指令
Instruction* find_inst(int insttype, BasicBlock* bb)
{
    for(Instruction* ins = bb->begin(); ins != bb->end(); ins = ins->getNext())
    {
        if(ins->getInstType() == insttype)
        {
            return ins;
        }
    }
    // assert(0 && "cannot find inst of specific type in given bb");
    return nullptr;
}

bool find_bb(BasicBlock* bb, Function* func)
{
    std::vector<BasicBlock *> blocklist = func->getBlockList();
    for(int i = 0; i < blocklist.size(); i ++)
    {
        if(blocklist[i]->getNo() == bb->getNo())
        {
            return true;
        }
    }
    return false;
}

// printf("is sitofp = %d\n", ins->isSitofp());
void Vectorization::doVectorization(loop_item* oneloop, Function* func)
{
    // std::cout<<"in doVectorization func first line\n";
    BasicBlock* cond_bb = oneloop->cond_bb;
    BasicBlock* body_bb = oneloop->while_bb;
    BasicBlock* end_bb = oneloop->end_bb;

    int vectorization_type = 0; // 0 --> no vectorization, 1 --> dst[i] = 0, 2 --> dst[i] = src[i]

    // if(this->condbb != nullptr)return;
    this->condbb = cond_bb;
    this->bodybb = body_bb;
    this->endbb = end_bb;

    // printf("cond_bb = %d\n", cond_bb->getNo());
    // printf("body_bb = %d\n", body_bb->getNo());
    // printf("end_bb = %d\n", end_bb->getNo());

    // 如果有函数调用，直接拒绝
    if(find_inst(Instruction::CALL, cond_bb) != nullptr)return;
    if(find_inst(Instruction::CALL, body_bb) != nullptr)return;
    if(find_inst(Instruction::CALL, end_bb) != nullptr)return;

    // 如果当前块已经在函数中被删除，说明该循环已经被循环展开了，拒绝
    if(find_bb(cond_bb, func) == false)return;
    if(find_bb(body_bb, func) == false)return;
    // 一般来说end_bb是不会被删除的
    // getchar();

    if(find_inst(Instruction::CMP, body_bb) == nullptr)
    {
        // 循环体的body块中没有cmp指令，很可能已经做过循环展开
        // 目前不再对这种情况进行向量化，就算做向量化，也另写一段操作
        return;
    }

    // 为后面补全循环次数做准备
    BasicBlock* condbb_copy = cond_bb->copybb(func);
    BasicBlock* bodybb_copy = body_bb->copybb(func);
    BasicBlock* endbb_copy = new BasicBlock(func);
    // BasicBlock* endbb_copy = end_bb->copybb(func);
    // wzr: 这里可能出问题，比如说bodybb的最后一条指令发现不是cond类型

    // printf("iscond? %d\n", find_inst(Instruction::COND, body_bb)->isCond());
    // displayBB(body_bb);
    // printf("mycond?\n");
    // display_instruction(find_inst(Instruction::COND, body_bb));
    // BasicBlock* tempbb1, *tempbb2;
    // BasicBlock* tempbb1 = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, body_bb))->getTrueBranch()->copybb(func);
    BasicBlock* tempbb1 = new BasicBlock(func);
    BasicBlock* tempbb2 = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, body_bb))->getFalseBranch()->copybb(func);

    int start, end;
    Operand* newend;
    Instruction* br = (body_bb->getBrorRet());
    Instruction* phi = body_bb->begin();
    //std::cout<<"before assert cond bb dose not start with phi\n";
    assert(phi->isPhi() && "cond bb dose not start with phi");
    auto operands = (dynamic_cast<PhiInstruction*>(phi))->getPhiOperands();
    auto bbs = (dynamic_cast<PhiInstruction*>(phi))->getPhiBBs();
    if(operands.size() != 2)
    {
        return;
    }
    if(!operands[0]->isConst())
    {
        return;
    }
    assert(bbs[0] != body_bb && "Inheriant const from loop by phi");
    
    start = operands[0]->getConstVal();
    // std::cout<<"start1 = "<<start<<"\n";
    Instruction* iter = operands[1]->getDef();
    Operand* myop = dynamic_cast<CondBrInstruction*>(br)->getCond();
    assert(myop != nullptr && "myop == nullptr");
    Instruction* comparer = myop->getDef();
    //std::vector<Operand*> ops = br->getOp();
    assert(comparer != nullptr && "br->getOp() == nullptr");
    if(!comparer->isCmp())
    {
        return;
    }
    //return;
    // 原本的常量循环展开非常量不展，但现在向量化变量也是可以做的
    // if(!comparer->getOp()[2]->isConst())
    // {
    //     return;
    // }
    // end = comparer->getOp()[2]->getConstVal();
    newend = comparer->getOp()[2];
    // printf("newend label = %d\n", newend->getLabel());
    // // may cause problem!!
    Operand* op1 = comparer->getOp()[1];
    Operand* op2 = op1->getDef()->getOp()[1];
    // phi->getDef();
    // if(op2 != phi->getDef())
    // {
    // #ifdef DEBUG0429_terminal
    //     std::cout<<"its no = "<<comparer->getOp()[1]->getLabel()<<"\n";
    //     std::cout<<"its no = "<<op2->getLabel()<<"\n";
    //     std::cout<<"comparer->getOp()[0] != phi\n";
    // #endif
    //     return;
    // }
    // printf("breakpoint\n");
    #ifdef DEBUG0429
    #endif
    // std::cout<<"stage2\n";
    //return;
    int iterPattern = -1;
    int accumulator;
    if(iter->getOp().size() != 3 || 
        !iter->getOp()[2]->isConst())
    {
        return;
    }
    // printf("iter inst = %s, dst = ");
    // display_instruction(iter);
    accumulator = iter->getOp()[2]->getConstVal();
    #ifdef DEBUG0429
    std::cout<<"accumulator = "<<accumulator<<"\n";
    #endif
    // 此处要做向量化，accumulator应该从1变成4
    // wzr: 如果accumulator不是1，不做，因为内存地址不连续的先不考虑
    if(accumulator != 1)
    {
        return;
    }
    // // 给他设置为4
    // iter->setOperand(2, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)));

    if(iter->isBin() && iter->getOpcode() == BinaryInstruction::ADD)
    {
        iterPattern = 0;
    }
    else if(iter->isBin() && iter->getOpcode() == BinaryInstruction::SUB)
    {
        // wzr: 减法的也先不管
        return;
        // iterPattern = 1;
        // accumulator = -accumulator;
    }
    else{
        return;
    }
    // 向量化的话，是不能要求算得出iternum的
    // int iternum = (end - start) / accumulator;
    // iternum = abs(iternum);
    // //std::cout<<"iternum  = "<<iternum<<"\n";
    // if(iternum > ITERBOUND)
    // {
    //     #ifdef DEBUG0429_terminal
    //         std::cout<<"(end - start) / accumulator > ITERBOUND\n";
    //     #endif
    //     return;
    // }
    // 向量化中没有这种可能
    // if(iterPattern == -1)
    // {
    //     #ifdef DEBUG0429_terminal
    //         std::cout<<"iterPattern == -1\n";
    //     #endif
    //     return;
    // }
    
    if(comparer->getOpcode() != CmpInstruction::L)
    {
        #ifdef DEBUG0429_terminal
            std::cout<<"comparer->getOpcode() != CmpInstruction::L\n";
        #endif
        return;
    }
    #ifdef DEBUG0429
    #endif
    
    // std::cout<<"stage3\n";
    std::unordered_set<Instruction*> ignored_ins{phi, comparer, br};
    #ifdef DEBUG0429
    std::cout<<"ignored: phi = "<<phi<<" comparer = "<<comparer<<" br = "<<br<<"\n";
    #endif
    // BasicBlock* outBB = oneloop->end_bb;
    // for(auto BB : cond_bb->getSuccBlock())
    // {
    //     if(BB != body_bb)outBB = BB;
    // }
    #ifdef DEBUG0429
    // std::cout<<"outBB.no = "<<outBB->getNo()<<"\n";
    #endif

        auto block_list0 = func->getBlockList();
        // for(int j = 0; j < block_list0.size(); j ++)
        // {
        //     // for(Instruction* ins = block_list[j]->begin(); ins != block_list[j]->end(); ins = ins->getNext())
        //     // {
        //     //     if(ins->isGep())
        //     //     {
        //     //         //std::cout<<"gepinst9 = "<<ins<<"\n";
        //     //         ArrayType* type =
        //     //                 (ArrayType*)(((PointerType*)(ins->getOp()[1]->getType()))->getType());
        //     //         //std::cout<<"origin ayyaytype type = "<<type->toStr()<<"\n";
        //     //         Type* elementType = type->getElementType();
        //     //         //std::cout<<"origin elementtype = "<<elementType<<"\n";  
        //     //     }
        //     // }
        //     //std::cout<<"bb No = "<<block_list0[j]->getNo()<<"\n";
        // }
        //std::cout<<"block_list.size() final = "<<block_list0.size()<<"\n";

    BasicBlock* new_bb = new BasicBlock(func);
    //std::cout<<"new_bb No = "<<new_bb->getNo()<<"\n";
    std::unordered_map<Instruction*, Instruction*> old2new;
    #ifdef DEBUG0429
    std::cout<<"start = "<<start<<" end = "<<end<<"\n";
    #endif

    //std::cout<<"doVectorization begin\n";
    std::vector<Function*> func_list = unit->get_functions();

    // printf("cond_bb = %d\n", cond_bb->getNo());
    // printf("body_bb = %d\n", body_bb->getNo());
    // printf("end_bb = %d\n", end_bb->getNo());
    // getchar();
    bool vectorization_stage1 = true;
    bool vectorization_stage2 = true;
    for(Instruction* ins = bodybb->begin(); ins != bodybb->end(); ins = ins->getNext())
    {
        if(ins->isGep() && !ins->getNext()->isGep())
        {
            if(!ins->getNext()->isStore())
            {
                // printf("the instruction next to gep is not store?\n");
                // return;
                vectorization_stage1 = false;
                break;
            }
            StoreInstruction* store = dynamic_cast<StoreInstruction*>(ins->getNext());
            // 下面这句assert(0)本意是好的，但是store的op1是指针类型，这种写法并不能正确比较两个label
            // printf("store op1 = %d, gep op0 = %d\n", store->getOp()[1]->getLabel(), ins->getOp()[0]->getLabel());
            // if(store->getOp()[1]->getLabel() != ins->getOp()[0]->getLabel())assert(0 && "the store you find doesn't match the gep above it");
            // 在这里卡一个条件，如果向数组中存入的不是个常数，本循环中是不做的
            // debug半小时，发现store指令的op0是指令横向阅读的第二个操作数
            // printf("store op1 value = %d\n", store->getOp()[1]->getSymbolEntry()->getType()->toStr().c_str());
            // printf("store op1 value = %d\n", store->getOp()[1]->toStr().c_str());
            // printf("store op1 value = %d\n", store->getOp()[1]->getLabel());
            // printf("store op1 isConstant? = %d\n", store->getOp()[1]->getSymbolEntry()->isConstant());
            // printf("store op1 isTemporary? = %d\n", store->getOp()[0]->getSymbolEntry()->isTemporary());
            // printf("store op1 isVariable? = %d\n", store->getOp()[0]->getSymbolEntry()->isVariable());
            // getchar();
            if(!store->getOp()[1]->isConst())
            {
                vectorization_stage1 = false;
                break;
            }
            // 指示这条store指令生成含有向量化(右端常数情况)的汇编
            store->setAsmType(1);
            asmChange = 1;
            vectorization_type = 1;
            // Operand* op0 = ins->getOp()[0];
            // printf("binary op0 = %d\n", op0->getLabel());
            // printf("op0 getDst = %d\n", op0->getDst()->getLabel());
            // Instruction* op0_def = op0->getDef()->getDef()->getDef();
            // printf("op0_def ins = %s\n", op0_def->getInstName().c_str());
            // for(int i = 0; i < op0_def->getOp().size(); i ++)
            // {
            //     printf("ins op%d = %d\n", i, op0_def->getOp()[i]->getLabel());
            // }
            break;
        }
    }
    
    // getchar();
    // 向量化dst[i] = 0 和dst[i] = src[i]的两种情况是互斥的
    if(!vectorization_stage1)
    {
        // 上面循环的写法有遗漏，如果bodybb中有两条及以上gep指令，store会出现在最后一条gep之后
        // 上面的循环判断会将这种情况break掉
        // 下面通过def-use关系找到dst[i] = src[i]这种情况，需要满足的条件如下：
        
        StoreInstruction* store_inbody = dynamic_cast<StoreInstruction*>(find_inst(Instruction::STORE, body_bb));
        assert(store_inbody->isStore());
        // conditino1: store指令的op1, op0都不是常数
        // condition2: store指令的op0(即dst)是一条GEP指令的dst, 如果它是一个全局变量（连数组都不是的那种），这里会报错，已修正
        if(!store_inbody->getOp()[0]->getDef())vectorization_stage2 = false;
        if(vectorization_stage2 && !store_inbody->getOp()[0]->getDef()->isGep())vectorization_stage2 = false;
        // getchar();
        GepInstruction* gep1_inbody;
        if(vectorization_stage2)gep1_inbody = dynamic_cast<GepInstruction*>(store_inbody->getOp()[0]->getDef());

        // condition3: store指令的op1(即src)是一条LOAD指令的dst
        // printf("store_inbody->getOp()[1] label = %d\n", store_inbody->getOp()[1]->getLabel());
        // display_instruction(store_inbody->getOp()[1]->getDef());
        if(vectorization_stage2 && !store_inbody->getOp()[1]->getDef()->isLoad())vectorization_stage2 = false;
        LoadInstruction* load_inbody1 = nullptr;
        if(vectorization_stage2)load_inbody1 = dynamic_cast<LoadInstruction*>(store_inbody->getOp()[1]->getDef());
        // condition4: 这条LOAD指令的op1(即src)是一条GEP指令的dst(如此，保证双方都是数组)
        if(vectorization_stage2 && !load_inbody1->getOp()[1]->getDef()->isGep())vectorization_stage2 = false;
        GepInstruction* gep2_inbody;
        if(vectorization_stage2)gep2_inbody = dynamic_cast<GepInstruction*>(load_inbody1->getOp()[1]->getDef());
        // getchar();
        // condition5: 这两条GEP指令的index都等于binary指令的op1(即循环变量)
        int binaryop1_label = iter->getOp()[1]->getLabel();
        if(vectorization_stage2 && gep1_inbody->getOp()[2]->getLabel() != binaryop1_label)vectorization_stage2 = false;
        if(vectorization_stage2 && gep2_inbody->getOp()[2]->getLabel() != binaryop1_label)vectorization_stage2 = false;
        
        // (如此，保证数组下标是连续的，其实是op1加一个常数或者不变的变量也可以，后期优化)
        if(vectorization_stage2)vectorization_type = 2;

        // 如果全部满足，指示这条store指令生成含有向量化(右端数组情况)的汇编
        if(vectorization_stage2){
            asmChange = 1;
            store_inbody->setAsmType(2);
        }
        // 别忘了还要指示那条load指令生成含有向量化(右端数组情况)的汇编
        if(vectorization_stage2){
            asmChange = 1;
            load_inbody1->setAsmType(2);
        }
        // ldr r4, [r2] --> vld1.u32 {q0}, [r2]!
        // str r4, [r2] --> vst1.u32 {q0}, [r2]!
    }

    // 如果上述条件有一条不满足，return,根本不做向量化的任何更改
    if(vectorization_stage1 == false && vectorization_stage2 == false)return;
    // getchar();
    
    // 不能在这个循环之前就setOperand，因为这个循环里如果发现store指令存的不是常数，也会返回
    if(asmChange==1)
        iter->setOperand(2, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)));

    // 目前为止，插入neon指令的工作已经完成
    // 但是运行时实际循环次数是不是4的倍数不好说，所以需要再写一个和原来很像的循环
    // 循环次数就是没有做完的那几次循环的个数
    // 思路是，在插向量化指令之前，先把原来的块全部深拷贝一遍√
    // 然后在下面的代码中改改寄存器号√
    // 还要处理寄存器和指令之间的def use dst关系
    // 修改跳转关系和块之间的前驱、后继关系√
    // 通过sub指令计算一下循环次数√
    // printf("condbb_copy label = %d\n", condbb_copy->getNo());
    // printf("bodybb_copy label = %d\n", bodybb_copy->getNo());
    // printf("endbb_copy label = %d\n", endbb_copy->getNo());
    // printf("tempbb1 label = %d\n", tempbb1->getNo());
    // printf("tempbb2 label = %d\n", tempbb2->getNo());

    
    // 1-1: 修正condbb_copy中的寄存器
    // displayBB(condbb_copy);
    // 需要插入sub指令计算新的循环变量值
    // Operand* iter_op1 = iter->getOp()[1];
    // // printf("iter op1 = %d\n", iter_op1->getLabel());
    // BinaryInstruction* newbinary = new BinaryInstruction(BinaryInstruction::SUB, 
    //     iter_op1, iter_op1, new Operand(new ConstantSymbolEntry(TypeSystem::intType, 4)));
    // // condbb_copy->insertFront(newbinary);
    // condbb_copy->insertBefore(newbinary, find_inst(Instruction::CMP, condbb_copy));
    // Instruction* newcmp_incond = find_inst(Instruction::CMP, condbb_copy);
    // // display_instruction(newcmp_incond);
    // newcmp_incond->setOperand(1, iter_op1);
    // CondBrInstruction* newbr_incond = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, condbb_copy));
    // // printf("newbr1 truebranch = %d, falsebranch = %d\n", newbr_incond->getTrueBranch()->getNo(), newbr_incond->getFalseBranch()->getNo());
    // newbr_incond->setTrueBranch(bodybb_copy);
    // newbr_incond->setFalseBranch(endbb_copy);
    // // printf("newbr2 truebranch = %d, falsebranch = %d\n", newbr_incond->getTrueBranch()->getNo(), newbr_incond->getFalseBranch()->getNo());

    // // 1-2: 修正bodybb_copy中的寄存器
    // CondBrInstruction* newbr_inbody = dynamic_cast<CondBrInstruction*>(find_inst(Instruction::COND, bodybb_copy));
    // newbr_inbody->setTrueBranch(tempbb1);
    // newbr_inbody->setFalseBranch(tempbb2);

    // // fixbug: 第一条load循环次数的指令下到汇编，不知为何没有从栈中拿[fp, #-4]，而是从[r0]，导致了段错误
    // // printf("cmp op2 = %d\n", find_inst(Instruction::CMP, bodybb_copy)->getOp()[2]->getLabel());
    // // printf("inst = %d\n", find_inst(Instruction::CMP, bodybb_copy)->getOp()[2]->getDef());
    // // getchar();
    // // Instruction* load_inbody = find_inst(Instruction::CMP, bodybb_copy)->getOp()[2]->getDef();
    // // 这种获取方式是片面的，本来应该按照上面的def关系获取，但这里的def关系没有维护好
    // Instruction* load_inbody = find_inst(Instruction::CMP, bodybb_copy)->getPrev();
    // // assert(load_inbody->isLoad());
    // if(load_inbody->isLoad())
    // {
    //     // display_instruction(load_inbody);
    //     // printf("load_incody = %d\n", load_inbody);
    //     load_inbody->setOperand(0, new Operand(new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel())));
    //     find_inst(Instruction::CMP, bodybb_copy)->setOperand(2, load_inbody->getOp()[0]);
    // }
    // // getchar();

    // // displayBB(bodybb_copy);
    // // BinaryInstruction* bin = dynamic_cast<BinaryInstruction*>(find_inst(Instruction::BINARY, bodybb_copy));
    // // display_instruction(bin);
    // // printf("bin op2 value = %d\n", bin->getOp()[2]->getConstVal());

    // // 1-3: 向tempbb2中填充指令
    // dynamic_cast<UncondBrInstruction*>(find_inst(Instruction::UNCOND, tempbb2))->setBranch(endbb_copy);
    // // displayBB(tempbb2);
    // // BinaryInstruction* bin_t1 = new BinaryInstruction(BinaryInstruction::ADD, );

    // // 1-4: 修改endbb_copy中的寄存器
    // // 我觉得不用改了，直接跳end_bb吧
    // // displayBB(endbb_copy);
    // // 已同时完成生成指令和插入指定块
    // UncondBrInstruction* uncond_inend = new UncondBrInstruction(end_bb, endbb_copy);

    // // 1-5: 让原endbb的第一个前驱块不要直接跳endbb，而是跳到我们的补偿循环开始块condbb_copy
    // // printf("endbb prevblock[0] = %d\n", endbb->getPredBlock()[0]->getNo());
    // // printf("endbb prevblock[1] = %d\n", endbb->getPredBlock()[1]->getNo());//√
    // // printf("bodybb succblock[0] = %d\n", body_bb->getSuccBlock()[0]->getNo());
    // // printf("bodybb succblock[1] = %d\n", body_bb->getSuccBlock()[1]->getNo());//√
    // // displayBB(body_bb->getSuccBlock()[1]);
    // BasicBlock* p_tempbb2 = body_bb->getSuccBlock()[1];
    // dynamic_cast<UncondBrInstruction*>(find_inst(Instruction::UNCOND, p_tempbb2))->setBranch(condbb_copy);
    // // displayBB(body_bb->getSuccBlock()[1]);

    // // 1-6: 发现tempbb1还是得有
    // BinaryInstruction* bin_inbody = dynamic_cast<BinaryInstruction*>(find_inst(Instruction::BINARY, bodybb_copy));
    // BinaryInstruction* bin_t1 = new BinaryInstruction(BinaryInstruction::ADD, 
    //     bin_inbody->getOp()[1], bin_inbody->getOp()[0], new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)), tempbb1);
    // UncondBrInstruction* uncond_t1 = new UncondBrInstruction(bodybb_copy, tempbb1);
    // // displayBB(tempbb1);
    // // getchar();

    // // 1-7: 发现原tempbb2块也不能直接跳到condbb_copy
    // // 如果循环次数正好是4的倍数，这个方法会死循环
    // // 所以加一条icmp指令，比较循环上限和当前循环次数
    // // 如果是小于，说明有漏下的，需要调condbb_copy
    // // 如果是等于，说明不需要补加
    // // 不可能是大于，那样根本不会跳出循环
    // // 记得把指令插入块

    // // fix(sl段错误): load_pt2的找法是不全面的，bodybb里cmp指令前的一条指令不一定是load
    // // 目前的想法是，如果它这里没有load，那可能根本没有这样一条load
    // // 我们这里直接拿来用就可以，也不用去load
    
    // LoadInstruction* load_pt2 = nullptr;
    // if(find_inst(Instruction::CMP, body_bb)->getPrev()->isLoad())
    // {
    //     load_pt2 = new LoadInstruction(new Operand(new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel())),
    //         find_inst(Instruction::CMP, body_bb)->getPrev()->getOp()[1]);
    // }
    // Operand* cmp_pt2_src1 = load_pt2 == nullptr ? find_inst(Instruction::CMP, body_bb)->getOp()[2] : load_pt2->getOp()[0];
    // // wzr: 此处找的不一定对，万一bodybb里还有别的binary指令, 所以用def关系找
    // Operand* cmp_pt2_src2 = find_inst(Instruction::CMP, body_bb)->getOp()[1]->getDef()->getOp()[1];
    // CmpInstruction* cmp_pt2 = new CmpInstruction(CmpInstruction::L, 
    //     new Operand(new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel())),
    //     cmp_pt2_src1, cmp_pt2_src2);
    // CondBrInstruction* cond_pt2 = new CondBrInstruction(condbb_copy, end_bb, cmp_pt2->getOp()[0]);
    // // p_tempbb2->clearInstructions();
    // if(load_pt2 != nullptr)
    //     p_tempbb2->insertBack(load_pt2);
    // p_tempbb2->insertBack(cmp_pt2);
    // p_tempbb2->insertBack(cond_pt2);
    // p_tempbb2->remove(find_inst(Instruction::UNCOND, p_tempbb2));
    // // displayBB(p_tempbb2);
    // // displayBB(p_tempbb2);
    // // getchar();
    // // p_tempbb2->insertBefore();

    // // 到此为止新块是无法被显示在中间代码/汇编中的
    // // 2: 整理块之间的前驱、后继关系
    // // 2-1: 原temp2增加跳到新condbb_copy的关系
    // // p_tempbb2->removeSucc(end_bb);
    // // end_bb->removePred(p_tempbb2);
    // p_tempbb2->addSucc(condbb_copy);
    // condbb_copy->addPred(p_tempbb2);

    // // 2-2: 新condbb_copy添加和新bodybb_copy的关系
    // condbb_copy->addSucc(bodybb_copy);
    // bodybb_copy->addPred(condbb_copy);
    
    // // 2-3: 新condbb_copy添加和新endbb_copy之间的关系
    // condbb_copy->addSucc(endbb_copy);
    // endbb_copy->addPred(condbb_copy);

    // // 2-4: 新bodybb_copy添加和tempbb1的关系
    // bodybb_copy->addSucc(tempbb1);
    // bodybb_copy->addPred(tempbb1);
    // tempbb1->addPred(bodybb_copy);
    // tempbb1->addSucc(bodybb_copy);

    // // 2-5: 新bodybb_copy添加和tempbb2的关系
    // bodybb_copy->addSucc(tempbb2);
    // tempbb2->addPred(bodybb_copy);

    // // 2-6: 新tembb2添加和新endbb_copy的关系
    // tempbb2->addSucc(endbb_copy);
    // endbb_copy->addPred(tempbb2);

    // // 2-7: 新endbb_copy添加和原end_bb的关系
    // endbb_copy->addSucc(end_bb);
    // end_bb->addPred(endbb_copy);
    
    // if(vectorization_stage1)vectorization_type = 1;
    // else if(vectorization_stage2)vectorization_type = 2;
    // printf("vectorization%d end\n", vectorization_type);
    return;
    getchar();
    std::vector<Instruction*> sitofps;
    // for(int h = 0; h < iternum; h ++)
    // {
    //     old2new.clear();
        
    //     #ifdef DEBUG0429
    //         std::cout<<"below transfer body_bb for insert\n";
    //     #endif
    //     //std::cout<<"iter1 = "<<iter<<"\n";
    //     body_bb->insertBefore(iter, comparer);
    //     body_bb->remove(iter);
    //     iter = comparer->getPrev();
    //     // std::cout<<"iter2 = "<<iter<<"\n";
    //     // 把外层循环i的值存回栈里
    //     // new StoreInstruction(dst, src, new_bb);
    //     // printf("body_bb next gep:\n");
    //     // for(int i = 0; i < body_bb->begin()->getNext()->getOp().size(); i ++)
    //     // {
    //     //     printf("operand%d = %d\n", i, body_bb->begin()->getNext()->getOp()[i]->getLabel());
    //     // }
    //     // 找到body块中的fsub指令，确认一下是否在copy时没有拷贝上浮点数信息
    //     Instruction* fsub = nullptr;
    //     Instruction* mysitofp = nullptr;
    //     for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    //     {
    //         // if(ins->isGep())
    //         // //else if(ins->isCall())
    //         // {
    //         //     // std::cout<<"isgep iscall 1\n";
    //         //     Operand* d = ins->getOp()[0];
    //         //     printf("0710: gep1 operands\n");
    //         // if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //         // {
    //         //     mysitofp = ins;
    //         //     printf("mysitofp = ins;\n");
    //         // }
    //         // printf("ins = %s\n", ins->getInstName().c_str());
    //         // printf("ins opcode = %d\n", ins->getOpcode());
    //         // for(int i = 0; i < ins->getOp().size(); i ++)
    //         // {
    //         //     printf("operand%d = %d\n", i, ins->getOp()[i]->getLabel());
    //         //     printf("operand%d type = %s\n", i, ins->getOp()[i]->getType()->toStr().c_str());
    //         // }
    //         if(ins->isBin() && ins->getOpcode() == 0)
    //         {
    //             fsub = ins;
    //         }
    //         // }
    //         // printf("is sitofp(out) = %d\n", ins->isSitofp());
    //         //if(ins == iter)std::cout<<"is iter1\n";
    //         //if(ins->isGep())std::cout<<"is gep1\n";
    //         // if(ins->isCall())
    //         // {
    //         //     std::cout<<"call dst = "<<ins->getDef()->getLabel()<<" call dst = "<<dynamic_cast<CallInstruction*>(ins)->dst->getLabel()<<"\n";
    //         // }
    //         if(ignored_ins.find(ins) != ignored_ins.end())
    //         {
    //             continue;
    //         }
    //         if(ins == iter || ins->isCond() || ins->isUncond())
    //         {
    //             continue;
    //         }
    //         // std::cout<<"??? instr name = "<<ins->getInstName()<<"\n";
    //         Instruction* new_ins = ins->copy(ins, new_bb);
    //         // std::cout<<"new>>>\n";
    //         old2new.insert({ins, new_ins});
    //         // std::cout<<"insert>>>\n";
    //         if(new_ins->isSitofp())
    //         {
    //             // printf("insert to sitofps\n");
    //             sitofps.push_back(new_ins);
    //         }

    //         // printf("new ins from copy");
    //         // printf("new ins = %s\n", old2new[ins]->getInstName().c_str());
    //         // printf("new ins opcode = %d\n", old2new[ins]->getOpcode());
    //         // for(int i = 0; i < old2new[ins]->getOp().size(); i ++)
    //         // {
    //         //     printf("operand%d = %d\n", i, old2new[ins]->getOp()[i]->getLabel());
    //         //     printf("operand%d type = %s\n", i, old2new[ins]->getOp()[i]->getType()->toStr().c_str());
    //         // }
    //     }

    //     // printf("mysitofp = %d\n", mysitofp);
    //     // 看看fsub转换成=的指令是不是浮点指令
    //     // printf("fsub = %d\n", fsub);
    //     // printf("fsub insname 1 = %s\n", fsub->getInstName().c_str());
    //     // printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //     // printf("fsub op0 type 1 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //     // printf("old fsub op0 type 1 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());

    //     #ifdef DEBUG0429
    //         std::cout<<"below transfer body_bb for exchange operand\n";
    //     #endif
    //     bool flag = false;
    //     //start -= accumulator;

        
    //     for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    //     {
    //         // if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //         // {
    //         //     // mysitofp = ins;
    //         //     printf("fsub 1 = %d\n", ins);
    //         //     printf("fsub 1 insname 3 = %s\n", ins->getInstName().c_str());
    //         //     printf("ins op0 label = %d, type = %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("ins op1 label = %d, type = %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //         // }
    //         // if(ins->isBin() && ins->getOp()[0]->getLabel() == 45)
    //         // {
    //         //     printf("fsub = %d\n", fsub);
    //         //     printf("fsub insname 3 = %s\n", fsub->getInstName().c_str());
    //         //     printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //         //     printf("fsub op0 type 3 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("old fsub op0 type 3 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());
    //         // }
    //         // printf("is sitofp(out) = %d\n", ins->isSitofp());
    //         //if(ins == iter)std::cout<<"is iter2\n";
    //         //if(ins->isGep())std::cout<<"is gep2\n";
    //         if(ignored_ins.find(ins) != ignored_ins.end())
    //         {
    //             continue;
    //         }
    //         if(ins == iter)
    //         {
    //             start += accumulator;
    //             //std::cout<<"start2 = "<<start<<"\n";
    //             continue;
    //         }
    //         else if(ins->isCond() || ins->isUncond())
    //         {
    //             continue;
    //         }
    //         else if(ins->isPhi())
    //         {
    //             continue;
    //         }
    //         else if(ins->isGep())
    //         //else if(ins->isCall())
    //         {
    //             // std::cout<<"isgep iscall 1\n";
    //             Operand* d = ins->getOp()[0];
    //             // printf("0710: gep operands\n");
    //             // for(int i = 0; i < ins->getOp().size(); i ++)
    //             // {
    //             //     printf("operand%d = %d\n", i, ins->getOp()[i]->getLabel());
    //             // }
    //             // std::cout<<"== "<<d->getType()->toStr()<<"\n";
                
    //             // Type* type = TypeSystem::floatType;
    //             Type* type = TypeSystem::intType;
    //             auto tmp = dynamic_cast<PointerType*>(d->getType());
    //             d = new Operand(new TemporarySymbolEntry(new PointerType(tmp->getType()), SymbolTable::getLabel()));
    //             //std::cout<<"setOperand 1\n";
    //             old2new[ins]->setOperand(0, d);
    //             // std::cout<<"isgep iscall 2\n";
    //         }
            
            
    //         #ifdef DEBUG0429
    //                 std::cout<<"ins op size = "<<ins->getOp().size()<<"\n";
    //         #endif
    //         if(ins->isStore() && ins->getPrev()->isGep() && (ins->getPrev()->getDef()->getUse()[0]) == ins)
    //         {
    //             //std::cout<<"setOperand 2\n";
    //             old2new[ins]->setOperand(0, old2new[ins->getPrev()]->getDef());
    //             //old2new[ins]->setOperand(1, old2new[ins->getPrev()]->getDef());
    //             //old2new[ins]->getDef()->getSymbolEntry()->setType(TypeSystem::intType);
    //             //continue;
    //             // std::cout<<"old2new[ins->getPrev()]->getDef() = "<<old2new[ins->getPrev()]->getDef()->toStr()<<"\n";
    //             // std::cout<<"old2new[ins->getPrev()]->getDef() = "<<old2new[ins->getPrev()]->getDef()->getType()->toStr()<<"\n";
    //             //std::cout<<"ins.getprev.getdef label = "<<old2new[ins->getPrev()]->getDef()->getLabel()<<"\n";
    //         }
    //         else if(ins->isLoad() && ins->getPrev()->isGep() && (ins->getPrev()->getDef()->getUse()[0]) == ins)
    //         {
    //             // old2new[ins]->setOperand(0, old2new[ins->getPrev()]->getDef());
    //             Type* tmptype = ins->getOp()[1]->getType();
    //             if(!tmptype->isPtr())
    //             {
    //                 assert(0 && "load operand1(src) type is not PTR!");
    //             }
    //             // dynamic_cast<PointerType*>(tmptype)->getType()->isFloat();
    //             if((dynamic_cast<PointerType*>(tmptype))->getType()->isInt()){
    //                 tmptype = TypeSystem::intType;
    //             }
    //             else if((dynamic_cast<PointerType*>(tmptype))->getType()->isFloat()){
    //             // printf("here!\n");
    //                 tmptype = TypeSystem::floatType;
    //             }
    //             Operand* newope = new Operand(new TemporarySymbolEntry(tmptype, SymbolTable::getLabel()));
    //             Operand* oldope = old2new[ins]->getOp()[0];
    //             // 拷贝def/use关系
    //             newope->setDef(ins);
    //             newope->addUse(old2new[ins->getNext()]);
    //             // newope->addUse(old2new[ins]->getNext());
    //             // printf("adduse who? %s\n", old2new[ins]->getNext()->getInstName().c_str());
    //             // printf("its operand1 is %d\n", old2new[ins]->getNext()->getOp()[1]->getLabel());
    //             // printf("oldope is %d\n", oldope->getLabel());

    //             old2new[ins]->setOperand(0, newope);
    //             // printf("ins operand1 : %d, %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //             // printf("ins operand2 : %d, %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //             // // printf("ins operand3 : %d\n", ins->getOp()[2]->getLabel());

    //             // printf("old2new ins operand1 : %d, %s\n", old2new[ins]->getOp()[0]->getLabel(), old2new[ins]->getOp()[0]->getType()->toStr().c_str());
    //             // printf("old2new ins operand2 : %d, %s\n", old2new[ins]->getOp()[1]->getLabel(), old2new[ins]->getOp()[1]->getType()->toStr().c_str());
    //             // printf("old2new ins operand3 : %d\n", old2new[ins]->getOp()[2]->getLabel());

    //             // printf("load next = %s\n", ins->getNext()->getInstName().c_str());
    //             // printf("load next is sitofp = %d\n", ins->getNext()->isSitofp());
    //             // printf("sitofp op0 = %d, op1 = %d\n", ins->getNext()->getOp()[0]->getLabel(), ins->getNext()->getOp()[1]->getLabel());
    //         }
            
    //         // if(ins->isBin() && ins->getOp()[0]->getLabel() == 45)
    //         // {
    //         //     printf("fsub = %d\n", fsub);
    //         //     printf("fsub insname 4 = %s\n", fsub->getInstName().c_str());
    //         //     printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //         //     printf("fsub op0 type 4 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("old fsub op0 type 4 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());
    //         // }

    //         // if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //         // {
    //         //     printf("fsub 2 = %d\n", ins);
    //         //     printf("fsub 2 insname 3 = %s\n", ins->getInstName().c_str());
    //         //     printf("ins op0 label = %d, type = %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("ins op1 label = %d, type = %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //         // }
            
    //         for(unsigned i = 1; i < ins->getOp().size(); i ++)
    //         {
    //             if(ins->isGep() && i == 1)
    //             {
    //                 if(ins->getOp()[1]->getDef() == nullptr)continue;
    //                 if(ins->getOp()[1]->getDef()->isGep())
    //                 {
    //                     // std::cout<<"gep but not the first\n";
    //                     old2new[ins]->setOperand(1, old2new[ins->getOp()[1]->getDef()]->getOp()[0]);
    //                 }
    //             }
                
    //             Instruction* ope = ins->getOp()[i]->getDef();
    //             if(ope == nullptr)
    //             {
    //                 //std::cout<<"continue\n";
    //                 continue;
    //             }
    //             if(ins->getOp()[i] == phi->getDef() || ope == iter)
    //             {
    //                 // if(ins->isSitofp())
    //                 //     std::cout<<"branch 1\n";
    //                 // old2new[ins]->setOperand(i, new Operand(new ConstantSymbolEntry(TypeSystem::floatType, start)));
    //                 old2new[ins]->setOperand(i, new Operand(new ConstantSymbolEntry(TypeSystem::constIntType, start)));
    //             }
    //             else if(old2new.find(ope) != old2new.end())
    //             {
    //                 #ifdef DEBUG0429
    //                     std::cout<<"branch old2new.find(ope) != old2new.end()\n";
    //                 #endif
    //                 // if(ins->isSitofp())
    //                 //     std::cout<<"branch2\n";
    //                 // printf("is sitofp = %d\n", ins->isSitofp());
    //                 //std::cout<<"setOperand 4\n";
    //                 old2new[ins]->setOperand(i, old2new[ope]->getOp()[0]);
    //                 if(ins->isStore() && i == 1 && ins->getPrev()->isGep())
    //                 {
    //                     // printf("gep before store op1 type = %s\n", ins->getPrev()->getOp()[1]->getSymbolEntry()->getType()->toStr().c_str());
    //                     assert(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType()->isPtr() && "gep op1 is not pointer type!! will cause nullptr fault!!");
    //                     // printf("isfloat? %d\n", dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->isFloat());
    //                     PointerType* mytype = dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType());
    //                     if(mytype->isPtr())
    //                     {
    //                         Type* mytype2 = mytype->getType();
    //                         if(mytype2->isArray())
    //                         {
    //                             // printf("in array branch\n");
    //                             if(dynamic_cast<ArrayType*>(mytype2)->getElementType()->isFloat())
    //                             {
    //                                 // printf("in array1 branch\n");
    //                                 old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                             }
    //                             else if(dynamic_cast<ArrayType*>(mytype2)->getElementType()->isInt())
    //                             {
    //                                 // printf("in array2 branch\n");
    //                                 old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::intType);
    //                                 // old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                             }
    //                             else
    //                             {
    //                                 printf("!!!gep before store op1 type's type = %s\n", dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->toStr().c_str());
    //                                 assert(0 && "not int type and not float type");
    //                             }
    //                         }
    //                         else
    //                         {

    //                             if(dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->isFloat())
    //                             {
    //                                 old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                             }
    //                             else if(dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->isInt())
    //                             {
    //                                 old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::intType);
    //                                 // old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);

    //                             }
    //                             else
    //                             {
    //                                 printf("!!!gep before store op1 type's type = %s\n", dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->toStr().c_str());
    //                                 assert(0 && "not int type and not float type");
    //                             }
    //                         }
    //                     }
    //                     else
    //                     {
    //                         assert(0 && "gep op1 type is not ptr");
    //                     }
    //                     // else if(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType()->isArray())
    //                     // {
    //                     //     printf("in array branch\n");
    //                     //     if(dynamic_cast<ArrayType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getElementType()->isFloat())
    //                     //     {
    //                     //         old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                     //     }
    //                     //     else if(dynamic_cast<ArrayType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getElementType()->isInt())
    //                     //     {
    //                     //         old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::intType);
    //                     //         // old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::floatType);
    //                     //     }
    //                     //     else
    //                     //     {
    //                     //         printf("!!!gep before store op1 type's type = %s\n", dynamic_cast<PointerType*>(ins->getPrev()->getOp()[1]->getSymbolEntry()->getType())->getType()->toStr().c_str());
    //                     //         assert(0 && "not int type and not float type");
    //                     //     }
    //                     // }
    //                 }
    //                     // old2new[ins]->getOp()[1]->getSymbolEntry()->setType(TypeSystem::intType);
    //                 // std::cout<<"old2new[ins]->getOp()[i] = "<<old2new[ins]->getOp()[i]->getType()->toStr()<<"\n";
    //                 // std::cout<<"old2new[ins]->getOp()[i] = "<<old2new[ins]->getOp()[i]->toStr()<<"\n";
    //                 old2new[ope]->getOp()[0]->addUse(old2new[ins]);
    //             }
    //             else
    //             {
    //                 #ifdef DEBUG0429
    //                                 std::cout<<"branch else\n";
    //                 #endif
    //                 // if(ins->isSitofp())
    //                 //     std::cout<<"branch3\n";
    //                 // printf("is sitofp = %d\n", ins->isSitofp());
    //                 //std::cout<<"setOperand 5\n";
    //                 old2new[ins]->setOperand(i, ope->getOp()[0]);
    //                 ope->getOp()[0]->addUse(old2new[ins]);
    //             }
    //             // std::cout<<"small loop end\n";
    //         }
    //             // std::cout<<"small loop end 2\n";
    //         // if(ins->isSitofp() && ins->getPrev()->isLoad())
    //         // {
    //         //     printf("sitofp op0 = %d, op1 = %d\n", ins->getOp()[0]->getLabel(), ins->getNext()->getOp()[1]->getLabel());
    //         //     printf("sitofp new op0 = %d, op1 = %d\n", old2new[ins]->getOp()[0]->getLabel(), old2new[ins]->getNext()->getOp()[1]->getLabel());
    //         // }

    //         // if(ins->isBin() && ins->getOp()[0]->getLabel() == 45)
    //         // {
    //         //     printf("fsub = %d\n", fsub);
    //         //     printf("fsub insname 5 = %s\n", fsub->getInstName().c_str());
    //         //     printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //         //     printf("fsub op0 type 5 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("old fsub op0 type 5 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());
    //         // }
    //         // if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //         // {
    //         //     printf("fsub 3 = %d\n", ins);
    //         //     printf("fsub 3 insname 3 = %s\n", ins->getInstName().c_str());
    //         //     printf("ins op0 label = %d, type = %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //         //     printf("ins op1 label = %d, type = %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //         // }
    //     }
        
    //     // 检验sitofp的参数类型
    //     // for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    //     // {
    //     //     if(ins->isSitofp() && ins->getOp()[0]->getLabel() == 68)
    //     //     {
    //     //         printf("fsub 4 = %d\n", ins);
    //     //         printf("fsub 4 insname 3 = %s\n", ins->getInstName().c_str());
    //     //         printf("ins op0 label = %d, type = %s\n", ins->getOp()[0]->getLabel(), ins->getOp()[0]->getType()->toStr().c_str());
    //     //         printf("ins op1 label = %d, type = %s\n", ins->getOp()[1]->getLabel(), ins->getOp()[1]->getType()->toStr().c_str());
    //     //     }
    //     // }
    //     // 看看fsub转换成的指令是不是浮点指令
    //     // printf("fsub = %d\n", fsub);
    //     // printf("fsub insname 2 = %s\n", fsub->getInstName().c_str());
    //     // printf("fsub dst op label = %d\n", fsub->getOp()[0]->getLabel());
    //     // printf("fsub op0 type 2 = %s\n", old2new[fsub]->getOp()[0]->getType()->toStr().c_str());
    //     // printf("old fsub op0 type 2 = %s\n", fsub->getOp()[0]->getType()->toStr().c_str());
    //     // assert(mysitofp != nullptr);
    //     // if(mysitofp->isSitofp() && mysitofp->getOp()[0]->getLabel() == 68)
    //     // {
    //     //     printf("mysitofp 1 = %d\n", mysitofp);
    //     //     printf("mysitofp 1 insname 3 = %s\n", mysitofp->getInstName().c_str());
    //     //     printf("mysitofp op0 label = %d, type = %s\n", mysitofp->getOp()[0]->getLabel(), mysitofp->getOp()[0]->getType()->toStr().c_str());
    //     //     printf("mysitofp op1 label = %d, type = %s\n", mysitofp->getOp()[1]->getLabel(), mysitofp->getOp()[1]->getType()->toStr().c_str());
    //     // }
        
    //     #ifdef DEBUG0429
    //         std::cout<<"after transfer body_bb for exchange\n";
    //     #endif
    //     for(Instruction* ins = new_bb->begin(); ins != new_bb->end(); ins = ins->getNext())
    //     {
    //         // if(ins->isCall())
    //         // {
    //         //     std::cout<<"call dst = "<<ins->getDef()->getLabel()<<" call dst = "<<dynamic_cast<CallInstruction*>(ins)->dst->getLabel()<<"\n";
    //         // }
    //     }
    // }
    // // for(Instruction* ins : sitofps)
    // {
    //     printf("one sitofps ins op0 = %d, op1 = %d\n", ins->getOp()[0]->getLabel(), ins->getOp()[1]->getLabel());
    // }
    #ifdef DEBUG0429
    std::cout<<"after while(start < end)\n";
    #endif
    // std::cout<<"stage4\n";
    old2new[iter] = new BinaryInstruction(BinaryInstruction::ADD, iter->getDef(), new Operand(new ConstantSymbolEntry(TypeSystem::intType, start)),
                                       new Operand(new ConstantSymbolEntry(TypeSystem::intType, accumulator)), new_bb);

    old2new.clear();
    std::unordered_map<Instruction*, Instruction*> old2new_;
    #ifdef DEBUG0429
    #endif
    Instruction* outbb_phi;
    Operand* outbb_phi_dst;
    // for(Instruction* ins = outBB->begin(); ins != outBB->end(); ins = ins->getNext())
    // {
    // // std::cout<<"ins = "<<ins<<"\n";
    //     // printf("is sitofp(outbb) = %d\n", ins->isSitofp());
    //     if(ins->isPhi()){
    //         outbb_phi = ins;
    //         outbb_phi_dst = ins->getDef();
    //         //std::cout<<"outbb_phi_dst = "<<outbb_phi_dst->toStr()<<"\n";
    //     }
    // // std::cout<<"ins.type = "<<ins->getInstName()<<"\n";
    // // std::cout<<"ins.ops = "<<ins->getOp().size()<<"\n";
    //     for(unsigned i = 0; i < ins->getOp().size(); i ++)
    //     {
    // // std::cout<<"breakpoint0\n";
    //         if(ins->getOp()[i] == nullptr)
    //         {
    //             continue;
    //         }
    //         Instruction* ope = ins->getOp()[i]->getDef();
    //         if(ope == nullptr)
    //         {
    // // std::cout<<"breakpoint1\n";
    //             #ifdef DEBUG0429_terminal
    //                         std::cout<<"ope == nullptr\n";
    //             #endif
    //             continue;
    //         }
    //         if(old2new_.find(ope) != old2new_.end())
    //         {
    // // std::cout<<"breakpoint2\n";
    //             ins->setOperand(i, old2new_[ope]->getOp()[0]);
    //         }
    //         else if(ope->isPhi())
    //         {
    // // std::cout<<"breakpoint3\n";
    //             ins->setOperand(i, new Operand(new ConstantSymbolEntry(TypeSystem::constIntType, start + accumulator)));
    //         }
    // // std::cout<<"breakpoint4\n";
    //     }
    // }

    // printf("bodybb = %d\n", body_bb->getNo());
    // printf("condbb label = %d\n", condbb->getNo());
    // printf("bodybb label = %d\n", bodybb->getNo());
    // wzr!!: 这里下面的getPredBlock()直接取[0]是有可能导致问题的
    BasicBlock* mtempbb = condbb->getPredBlock()[0];
    BasicBlock* mtembbb_prev = mtempbb->getPredBlock()[0];
    // printf("mtempbb label = %d\n", mtempbb->getNo());
    // for(Instruction* ins = bodybb->begin(); ins != bodybb->end(); ins = ins->getNext())
    // {
    //     // printf("ins = %d\n", ins);
    //     // printf("ins = %s\n", ins->getInstName().c_str());
    //     // if(ins->isLoad())
    //     // {
    //     //     printf("ins op0 = %d\n", ins->getOp()[0]->getLabel());
    //     //     printf("ins op1 = %d\n", ins->getOp()[1]->getLabel());
    //     //     // printf("ins op2 = %d\n", ins->getOp()[2]->getLabel());
    //     //     // printf("ins op3 = %d\n", ins->getOp()[3]->getLabel());
    //     // }
    //     for(int i = 0; i < ins->getOp().size(); i ++)
    //     {
    //         // printf("ins op%d = %d\n", i, ins->getOp()[i]->getLabel());
    //     }
    //     if(ins->isBin())
    //     {
    //         Operand* op0 = ins->getOp()[0];
    //         // printf("binary op0 = %d\n", op0->getLabel());
    //         // printf("op0 getDst = %d\n", op0->getDst()->getLabel());

    //         // 补一个alloca
    //         // wzr!!: 不知道初始化alloca指令的第二个参数传对没
    //         AllocaInstruction* alloca_j = new AllocaInstruction(op0->getDst(), op0->getDst()->getSymbolEntry());
    //         // func->getEntry()->insertFront(alloca_j);
    //         // Instruction* op0_def = op0->getDef()->getDef()->getDef();
    //         // // printf("op0_def ins = %s\n", op0_def->getInstName().c_str());
    //         // for(int i = 0; i < op0_def->getOp().size(); i ++)
    //         // {
    //         //     // printf("ins op%d = %d\n", i, op0_def->getOp()[i]->getLabel());
    //         // }
    //         // printf("accumulator = %d\n", accumulator);
    //         // printf("start = %d\n", start);
    //         // new StoreInstruction(op0->getDst(), new Operand(new ConstantSymbolEntry(TypeSystem::intType, start)), new_bb);
    //     }
    // }

    // printf("body_bb next gep:\n");
    // for(int i = 0; i < body_bb->begin()->getNext()->getOp().size(); i ++)
    // {
    //     printf("operand%d = %d\n", i, body_bb->begin()->getNext()->getOp()[i]->getLabel());
    // }

    // printf("below traverse tempbb_prev, as 299\n");
    // for(Instruction* ins = mtembbb_prev->begin(); ins != mtembbb_prev->end(); ins = ins->getNext())
    // {
    //     // printf("ins = %d\n", ins);
    //     // printf("ins = %s\n", ins->getInstName().c_str());
    //     // if(ins->isLoad())
    //     // {
    //     //     printf("ins op0 = %d\n", ins->getOp()[0]->getLabel());
    //     //     printf("ins op1 = %d\n", ins->getOp()[1]->getLabel());
    //     //     // printf("ins op2 = %d\n", ins->getOp()[2]->getLabel());
    //     //     // printf("ins op3 = %d\n", ins->getOp()[3]->getLabel());
    //     // }
    //     for(int i = 0; i < ins->getOp().size(); i ++)
    //     {
    //         // printf("ins op%d = %d\n", i, ins->getOp()[i]->getLabel());
    //     }
    //     if(ins->isBin())
    //     {
    //         // Operand* op0 = ins->getOp()[0];
    //         // printf("binary op0 = %d\n", op0->getLabel());
    //         // printf("op0 getDst = %d\n", op0->getDst()->getLabel());

    //         // 补一个alloca
    //         // wzr!!: 不知道初始化alloca指令的第二个参数传对没
    //         // AllocaInstruction* alloca_j = new AllocaInstruction(op0->getDst(), op0->getDst()->getSymbolEntry());
    //         // func->getEntry()->insertFront(alloca_j);
    //         // Instruction* op0_def = op0->getDef()->getDef()->getDef();
    //         // printf("op0_def ins = %s\n", op0_def->getInstName().c_str());
    //         // for(int i = 0; i < op0_def->getOp().size(); i ++)
    //         // {
    //         //     printf("ins op%d = %d\n", i, op0_def->getOp()[i]->getLabel());
    //         // }
    //         // printf("accumulator = %d\n", accumulator);
    //         // printf("start = %d\n", start);
    //         // new StoreInstruction(op0->getDst(), new Operand(new ConstantSymbolEntry(TypeSystem::intType, start)), new_bb);
    //     }
    // }

    // Operand* mop2 = body_bb->begin()->getNext()->getOp()[2];
    // Operand* mop2 = nullptr;
    // for(Instruction* mins = body_bb->begin(); mins != body_bb->end(); mins = mins->getNext())
    // {
    //     // printf("!!!mins = %s\n", mins->getInstName().c_str());
    //     // printf("mins = %s\n", mins->getInstName().c_str());
    //     if(mins->isGep() && !mins->getNext()->isGep())
    //     {
    //         if(mins->getPrev()->isGep())
    //         {
    //             // printf("mop2 branch1\n");
    //             mop2 = mins->getPrev()->getOp()[2];
    //         }
    //         else
    //         {
    //             // printf("mop2 branch2\n");
    //             mop2 = mins->getOp()[2];
    //         }
    //         // printf("in!!\n");
    //         // mtempbb->insertBefore(i_str, mins);
    //         break;
    //     }
    // }
    // assert(mop2 != nullptr);
    // printf("mop2 = %d\n", mop2->getLabel());
    // printf("traverse end_bb, find i's addr\n");
    LoadInstruction* i_load = nullptr;
    Instruction* i_binary = nullptr;
    // printf("end_bb no = %d\n", end_bb->getNo());
    // for(Instruction* ins = end_bb->begin(); ins != end_bb->end(); ins = ins->getNext())
    // {
    //     // printf("ins = %d\n", ins);
    //     // printf("ins = %s\n", ins->getInstName().c_str());
    //     // printf("op size = %d\n", ins->getOp().size());
    //     for(int i = 0; i < ins->getOp().size(); i ++)
    //     {
    //         if(ins->getOp()[i] == nullptr)
    //         {
    //             // printf("op%d == nullptr, next\n", i);
    //             continue;
    //         }
    //         // assert(0 && "ins->getOp()[i] == nullptr");
    //         // printf("ins op%d = %d\n", i, ins->getOp()[i]->getLabel());
    //     }
    //     // printf("after print ops\n");
    //     if(ins->isBin())
    //     {
    //         Operand* op0 = ins->getOp()[0];
    //         // printf("binary op0 = %d\n", op0->getLabel());
    //         // assert(op0->getDst() != nullptr);
    //         // printf("op0 getDst = %d\n", op0->getDst()->getLabel());
    //         if(op0->getDst() == nullptr)
    //         {
    //             break;
    //         }
    //         //wzr !!
    //         // AllocaInstruction* alloca_i = new AllocaInstruction(op0->getDst(), op0->getDst()->getSymbolEntry());
    //         // printf("func entrybb = %d\n", func->getEntry()->getNo());
    //         // func->getEntry()->insertFront(alloca_i);
    //         // Instruction* op0_def = op0->getDef()->getDef()->getDef();
    //         // printf("op0_def ins = %s\n", op0_def->getInstName().c_str());
    //         // for(int i = 0; i < op0_def->getOp().size(); i ++)
    //         // {
    //         //     printf("ins op%d = %d\n", i, op0_def->getOp()[i]->getLabel());
    //         // }

    //         // printf("mop2 label = %d\n", mop2->getLabel());
    //         // printf("mop2 dst = %d\n", mop2->getDst());
    //         // printf("nextline\n");

    //         // StoreInstruction* i_str = new StoreInstruction(mop2->getDst(), mop2, nullptr);
    //         StoreInstruction* i_str = new StoreInstruction(op0->getDst(), mop2, nullptr);
    //         // mtempbb->insertFront(i_str);
    //         // printf("mtempbb no = %d\n", mtempbb->getNo());
    //         for(Instruction* mins = mtempbb->begin(); mins != mtempbb->end(); mins = mins->getNext())
    //         {
    //             // printf("!!!mins = %s\n", mins->getInstName().c_str());
    //             if(!mins->isPhi())
    //             {
    //                 // printf("in!!\n");
    //                 mtempbb->insertBefore(i_str, mins);
    //                 break;
    //             }
    //         }
    //         // for(Instruction* mins = mtempbb->end(); mins != mtempbb->begin(); mins = mins->getPrev())
    //         // {
    //         //     // printf("!!!mins = %s\n", mins->getInstName().c_str());
    //         //     if(mins->isGep())
    //         //     {
    //         //         if(mins->getPrev()->isGep())
    //         //         {

    //         //         }
    //         //         else
    //         //         {

    //         //         }
    //         //         // printf("in!!\n");
    //         //         mtempbb->insertBefore(i_str, mins);
    //         //         break;
    //         //     }
    //         // }
    //         // printf("mtembb end def = %d\n", mtempbb->end()->getDef()->getLabel());
    //         // mtempbb->insertBefore(i_str, mtempbb->end());
            
    //         i_load = new LoadInstruction(op0, op0->getDst(), nullptr);

    //         ins->setOperand(1, op0);
    //     }
    //     if(ins->isBin())
    //     {
    //         i_binary = ins;
    //     }   
    // }
    // // std::cout<<"stage5\n";
    // 把i_load插入end_bb中binary指令前
    // if(i_binary != nullptr)
    // {
    //     end_bb->insertBefore(i_load, i_binary);
    // }

    // 向end_bb里插入从i_addr中load i值的语句


    //std::cout<<"body_bb->getSuccBlock().size()1 = "<<body_bb->getSuccBlock().size()<<"\n";
    // Instruction* binaryins = new BinaryInstruction(BinaryInstruction::ADD, outbb_phi_dst, iter->getDef(),
    //                                    new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0)));
    // outBB->insertFront(binaryins);
    // outBB->remove(outbb_phi);

    //clear

    // cond_bb->clearInstructions();
    // body_bb->clearInstructions();

    //return;
    // UncondBrInstruction* uncondbr = new UncondBrInstruction(outBB, new_bb);
    // new_bb->addSucc(outBB);
    // outBB->addPred(new_bb);
    // for(BasicBlock* pred_cond : cond_bb->getPredBlock())
    // {
    //     if(pred_cond == body_bb)
    //     {
    // #ifdef DEBUG0429_terminal
    //         std::cout<<"pred_cond == body_bb\n";
    // #endif
    //         continue;
    //     }
    //     Instruction* b = pred_cond->getBrorRet();
    //     if(b->getInstName() == "COND")
    //     {
    //         CondBrInstruction* condbr = dynamic_cast<CondBrInstruction*>(b);
    //         if(condbr->getTrueBranch() == cond_bb)
    //         {
    //             condbr->setTrueBranch(new_bb);
    //             pred_cond->addSucc(new_bb);
    //             pred_cond->removeSucc(cond_bb);
    //             //new_bb->removePred(pred_cond);
    //             new_bb->addPred(pred_cond);
    //         }
    //         else if(condbr->getFalseBranch() == cond_bb)
    //         {
    //             condbr->setFalseBranch(new_bb);
    //             pred_cond->addSucc(new_bb);
    //             pred_cond->removeSucc(cond_bb);
                
    //             new_bb->addPred(pred_cond);
    //         }
    //     }
    //     else if(b->getInstName() == "UNCOND")
    //     {
    //         UncondBrInstruction* uncondbr = dynamic_cast<UncondBrInstruction*>(b);
    //         if(uncondbr->getBranch() == cond_bb)
    //         {
    //             uncondbr->setBranch(new_bb);
    //             pred_cond->addSucc(new_bb);
    //             pred_cond->removeSucc(cond_bb);
    //             new_bb->addPred(pred_cond);
    //         }
    //     }
    // }

    

    // std::cout<<"stage6\n";

    // std::cout<<"cond_bb = "<<cond_bb->getNo()<<"\n";
    // if(cond_bb != nullptr)
    //     cond_bb->deleteAllRelation();
    // cond_bb->getParent()->remove(cond_bb);
    // std::cout<<"body_bb = "<<body_bb->getNo()<<"\n";
    // cond_bb->removeSucc(oneloop->while_bb);
    // body_bb->removePred(cond_bb);
    // std::cout<<"end_bb = "<<oneloop->end_bb->getNo()<<"\n";
    
    //new_bb->addPred(cond_bb->getPrevbb());
    //cond_bb->getPrevbb().addSucc(new_bb)


    // std::cout<<"depend relation begin\n";
    
    // cond_bb->getPredBlock().clear();

    //std::cout<<"body_bb->getSuccBlock().size() = "<<body_bb->getSuccBlock().size()<<"\n";
    // std::vector<BasicBlock*> temp;
    // for(BasicBlock* prev_cond : cond_bb->getPrevbb())
    // {
    //     // body_bb->removeSucc(succ_body);
    //     // succ_body->removePred(body_bb);
    //     //std::cout<<"bodybb succ_bb = "<<succ_body->getNo()<<"\n";
    //     prev_cond->addSucc(new_bb);
    //     new_bb->addPred(prev_cond);
    // }
    // for(BasicBlock* prev_cond : cond_bb->getPrevbb())
    // {
    //     prev_cond->removeSucc(cond_bb);
    // }
    
    // for(BasicBlock* succ_body : body_bb->getSuccBlock())
    // {
    //     end_bb->removePred(succ_body);
    // }
    // body_bb->getSuccBlock().clear();

    // std::cout<<"depend relation end\n";
    //body_bb->removeSucc(oneloop->end_bb);
    // end_bb->removePred(body_bb);

    // cond_bb->getParent()->remove(cond_bb);
    // body_bb->getParent()->remove(body_bb);

    // std::cout<<"!!\n";
    //body_bb->removePred(cond_bb);
    // cond_bb->removeSucc(body_bb);
    // std::cout<<"!!!\n";
    // std::cout<<"cond_bb = "<<cond_bb->getNo()<<"\n";
    // std::cout<<"body_bb = "<<body_bb->getNo()<<"\n";
    // std::cout<<"end_bb = "<<oneloop->end_bb->getNo()<<"\n";
    //outBB->removePred(cond_bb);
    // for(Instruction* ins = cond_bb->begin(); ins != cond_bb->end(); ins = ins->getNext())
    // {
    //     //ins.removeUseOfOps()
    // }
    // for(Instruction* ins = body_bb->begin(); ins != body_bb->end(); ins = ins->getNext())
    // {
    //     //ins.removeUseOfOps()
    // }

    // func_list = unit->get_functions();

    //     std::vector<BasicBlock*> block_list = func->getBlockList();
    //     for(int j = 0; j < block_list.size(); j ++)
    //     {
    //         // for(Instruction* ins = block_list[j]->begin(); ins != block_list[j]->end(); ins = ins->getNext())
    //         // {
    //         //     if(ins->isGep())
    //         //     {
    //         //         //std::cout<<"gepinst9 = "<<ins<<"\n";
    //         //         ArrayType* type =
    //         //                 (ArrayType*)(((PointerType*)(ins->getOp()[1]->getType()))->getType());
    //         //         //std::cout<<"origin ayyaytype type = "<<type->toStr()<<"\n";
    //         //         Type* elementType = type->getElementType();
    //         //         //std::cout<<"origin elementtype = "<<elementType<<"\n";  
    //         //     }
    //         // }
    //         //std::cout<<"bb No = "<<block_list[j]->getNo()<<"\n";
    //     }
    //     //std::cout<<"block_list.size()"<<block_list.size()<<"\n";
    // //std::cout<<"=============================================\n";

    std::vector<BasicBlock*> BBs = func->getBlockList();
    
    // std::cout<<"cond_bb = "<<cond_bb->getNo()<<"\n";
    // std::cout<<"body_bb = "<<body_bb->getNo()<<"\n";
    // std::cout<<"end_bb = "<<oneloop->end_bb->getNo()<<"\n";
    //func->getBlockList().push_back(new_bb);
    // std::cout<<"BBs.size()1 = "<<BBs.size()<<"\n";
    
    // for (auto bb = func->getBlockList().begin(); bb != func->getBlockList().end();)
    // {
    //     if(*bb == cond_bb)
    //     {
    //         func->getBlockList().erase(bb);
    //         std::cout<<"after erase cond_bb\n";
    //         std::cout<<"bb No = "<<(*bb)->getNo()<<"\n";
    //         std::cout<<"func->getBlockList().size()2 = "<<func->getBlockList().size()<<"\n";
    //     }
    //     else if(*bb == body_bb)
    //     {
    //         func->getBlockList().erase(bb);
    //         std::cout<<"after erase body_bb\n";
    //         std::cout<<"bb No = "<<(*bb)->getNo()<<"\n";
    //         std::cout<<"func->getBlockList().size()3 = "<<func->getBlockList().size()<<"\n";
    //     }
    //     else
    //     {
    //         bb ++;
    //     }
    // }
    // std::cout<<"func->getBlockList().size()4 = "<<func->getBlockList().size()<<"\n";
    // std::cout<<"func->getBlockList().size() = "<<func->getBlockList().size()<<"\n";
    
    // func->remove(cond_bb);
    // func->remove(body_bb);
    
    // bool findPhi = false;
    // PhiInstruction* phi_next = nullptr;
    // BasicBlock* searchBB = end_bb;
    // while(!findPhi && searchBB != nullptr)
    // {
    //     std::cout<<"while\n";
    //     for(Instruction* ins = searchBB->begin(); ins != searchBB->end(); ins = ins->getNext())
    //     {
    //         if(ins->isPhi())
    //         {
    //             std::cout<<"isphi\n";
    //             findPhi = true;
    //             phi_next = dynamic_cast<PhiInstruction*>(ins);
    //             break;
    //         }
    //         else if(ins->isUncond())
    //         {
    //             searchBB = dynamic_cast<UncondBrInstruction*>(ins)->getBranch();
    //             std::cout<<"searchBB no = "<<searchBB->getNo()<<"\n";
    //         }
    //     }
    // }

    

    #ifdef DEBUG0429
    #endif

    std::cout<<"doVectorization end\n";
    // func_list = unit->get_functions();

    //     block_list = func->getBlockList();
    //     for(int j = 0; j < block_list.size(); j ++)
    //     {
    //         // for(Instruction* ins = block_list[j]->begin(); ins != block_list[j]->end(); ins = ins->getNext())
    //         // {
    //         //     if(ins->isGep())
    //         //     {
    //         //         //std::cout<<"gepinst9 = "<<ins<<"\n";
    //         //         ArrayType* type =
    //         //                 (ArrayType*)(((PointerType*)(ins->getOp()[1]->getType()))->getType());
    //         //         //std::cout<<"origin ayyaytype type = "<<type->toStr()<<"\n";
    //         //         Type* elementType = type->getElementType();
    //         //         //std::cout<<"origin elementtype = "<<elementType<<"\n";  
    //         //     }
    //         // }
    //         //std::cout<<"bb No = "<<block_list[j]->getNo()<<"\n";
    //     }
        //std::cout<<"block_list.size() final = "<<block_list.size()<<"\n";
    // std::cout<<"doVectorization check end\n";
    // func->getBlockList()->erase(cond_bb);
    // func->getBlockList()->erase(cond_bb);

    // cond_bb->clearInstructions();
    // body_bb->clearInstructions();

    // cond_bb->getParent()->remove(cond_bb);
    // body_bb->getParent()->remove(body_bb);
    // func.geten
    // func->getEntry()->insertBack(i_load);

}
